package gui;

import java.awt.*;
import java.awt.image.*;

import aos.util.Properties;

public class Banner extends Panel {

    class LogoPanel extends Panel {

	class Logo extends Canvas implements ImageObserver {

	    Image im;

	    Logo(String gif)
	    {
		im = Toolkit.getDefaultToolkit().getImage(gif);
		prepareImage(im,-1,-1,this);
	    }

	    public void update(Graphics g) { paint(g); }

	    public boolean imageUpdate(Image im,int f,int x,int y,int w,int h)
	    {
		if ((f & ImageObserver.ALLBITS) != 0) {
		    setSize(w,h);
		    LogoPanel.this.getLayout().layoutContainer(LogoPanel.this);
		    Banner.this.getLayout().layoutContainer(Banner.this);
		    repaint();
		}
		return ((f & (ImageObserver.ALLBITS |
			      ImageObserver.ABORT)) == 0);
	    }

	    public void paint(Graphics g)
	    {
		g.drawImage(im,0,0,this);
	    }

	}

	LogoPanel(String gif)
	{
	    super(new FlowLayout());
	    add(new Logo(gif));
	}
    }

    int w;
    int h;

    public Dimension getPreferredSize()
    {
	Dimension m = getMinimumSize();
	if (m.width < w)
	    m.width = w;
	if (m.height < h)
	    m.height = h;
	return m;
    }

    Banner(String gif)
    {
	super(new BorderLayout());
	add(new LogoPanel(Properties.getStringProperty("Banner.gif",gif)),
	    "Center");
	add(new Label("(R) JACK Intelligent Agents",
		      Label.LEFT),"South");
	add(new Label("Copyright 1999, Agent Oriented Software Pty. Ltd.",
		      Label.LEFT),"North");
	w = Properties.getIntProperty("Banner.width",100);
	h = Properties.getIntProperty("Banner.height",140);

	setSize(w,h);
    }
}
