package gui;

import java.awt.*;
import java.io.*;
import java.awt.event.*;

import agents.*;

public class GUI extends Frame implements AtmInterface {
    MenuBar		menuBar;
    Panel		subpanel;
    CardLayout		cl;
    Frame		panel;
    MenuItem		item;

    public AtmClient		atm;
    public int			account = -1;
    public int			pin;
    public boolean		quick = false;

    private Component		next_f;
    private TextField		message_f;
    private TextField		account_f;
    private TextField		pin_f;
    private TextField		cash_f;
    private TextField		balance_f;
    private TextField		wamount_f;
    private TextField		damount_f;
    private TextField		tamount_f;
    private TextField		taccount_f;
    private TextArea		statement_f;

    public void register(AtmClient a)
    {
	atm = a;
    }

    public void dispense(int amount)
    {
	cash_f.setText("" + amount);
    }

    public void receipt(int account,int balance)
    {
	balance_f.setText("" + balance);
    }

    public void eject()
    {
	message_f.setText("CARD EJECTED");
	account_f.setText("");
	account = -1;
	pin = -1;
	pin_f.setText("");
	pin_f.setEditable(false);
    }

    public void message(String s)
    {
	message_f.setText(s);
    }

    public boolean cardInserted()
    {
	return account > 0;
    }

    public void withdraw(int amount)
    {
	if (account < 0)
	    message("Enter account number first");
	else if (pin < 0)
	    message("Enter pin number first");
	else {
	    message("Processing withdraw $" + amount);
	    atm.withdraw(amount);
	}
    }

    public GUI()
    {
	super("ATM Example");

	Panel		p1, p2, p3;

	menuBar = new MenuBar();

	Menu file = new Menu("File");
	item = new MenuItem("Exit");
	item.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    System.exit(1);
		}});

	file.add(item);

	menuBar.add(file);
	setMenuBar(menuBar);
	panel = this;
	panel.setLayout(new GridBagLayout());
	addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    System.exit(1);
		}});
	addComponent(panel, message_f =
		     new TextField(30), 0, 0, 2, 1, .5, .1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(panel, new Label("Account", Label.RIGHT),
		     0, 1, 1, 1, .5,.1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(panel, account_f = new TextField(15), 1, 1, 1, 1, .5,.1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(panel, new Label("PIN", Label.RIGHT), 0, 2, 1, 1, .5,.1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(panel, pin_f = new TextField(15), 1, 2, 1, 1, .5,.1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(panel, new Label("Balance", Label.RIGHT), 0,3,1, 1, .5,.1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(panel, balance_f = new TextField(), 1, 3, 1, 1, .5,.1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(panel, new Label("Cash", Label.RIGHT), 0, 4, 1, 1, .5,.1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(panel, cash_f = new TextField(), 1, 4, 1, 1, .5,.1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);

	Choice	c = new Choice();
	addComponent(panel, c, 0, 5, 1, 1, .5,.1,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	c.addItem("Withdraw");
	c.addItem("Deposit");
	c.addItem("Transfer");
	c.addItem("Statement");
	c.addItemListener(
	    new ItemListener() {
		    public void itemStateChanged(ItemEvent e)
		    {
			String s;
			cl.show(subpanel, s = (String)e.getItem());
			if (s.equals("Withdraw"))
			    next_f = wamount_f;
			else if (s.equals("Deposit"))
			    next_f = damount_f;
			else if (s.equals("Transfer"))
			    next_f = taccount_f;
			else
			    next_f = statement_f;
		    }
		}
	    );

	subpanel = new Panel();
	addComponent(panel, subpanel, 0, 6, 2, 4, .4, 1.0,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	cl = new CardLayout();
	subpanel.setLayout(cl);

	p1 = new Panel();
	p1.setLayout(new GridBagLayout());
	addComponent(p1, new Label("Amount", Label.RIGHT), 0, 0, 1, 1, .5,0,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(p1, wamount_f = new TextField(15), 1, 0, 1, 1, .5, 0,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	subpanel.add("Withdraw", p1);
	p1 = new Panel();
	p1.setLayout(new GridBagLayout());
	addComponent(p1, new Label("Amount", Label.RIGHT), 0, 0, 1, 1, .5,0,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(p1, damount_f = new TextField(15), 1, 0, 1, 1, .5, 0,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	subpanel.add("Deposit", p1);
	p1 = new Panel();
	p1.setLayout(new GridBagLayout());
	addComponent(p1, new Label("Account", Label.RIGHT), 0, 0, 1, 1, .5,0,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(p1, taccount_f = new TextField(15), 1, 0, 1, 1, .5, 0,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(p1, new Label("Amount", Label.RIGHT), 0, 1, 1, 1, .5,0,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	addComponent(p1, tamount_f = new TextField(15), 1, 1, 1, 1, .5, 0,
		     GridBagConstraints.BOTH, GridBagConstraints.CENTER);
	subpanel.add("Transfer", p1);
	p1 = new Panel();
	p1.setLayout(new GridBagLayout());
	p1.add(statement_f = new TextArea("", 6, 40));
	subpanel.add("Statement", p1);

	// No set attributes and event handlers
	message_f.setEditable(false);
	pin_f.setEditable(false);
	pin_f.setEchoChar('*');
	balance_f.setEditable(false);
	cash_f.setEditable(false);
	next_f = wamount_f;
	account_f.requestFocus();
	account_f.addActionListener(
	    new ActionListener() {
		    public void actionPerformed(ActionEvent e) {
			try {
			    int i = Integer.parseInt(e.getActionCommand());
			    account = i;
			    pin_f.setEditable(true);
			    pin_f.requestFocus();
			}
			catch (Exception e1) {
			    System.err.println("Invalid account number");
			}
		    }
		}
	    );
	pin_f.addActionListener(
	    new ActionListener() {
		    public void actionPerformed(ActionEvent e) {
			try {
			    int i = Integer.parseInt(e.getActionCommand());
			    pin = i;
			    next_f.requestFocus();
			    atm.insertCard(account, pin);
			}
			catch (Exception e2) {
			    System.err.println("Invalid pin number");
			}
		    }
		}
	    );
	wamount_f.addActionListener(
	    new ActionListener() {
		    public void actionPerformed(ActionEvent e) {
			try {
			    int i = Integer.parseInt(e.getActionCommand());
			    withdraw(i);
			}
			catch (Exception e3) {
			    System.err.println("Invalid amount"+e3);
			}
		    }
		}
	    );
    }

    private void
    addComponent(Container ct, Component cp, int x, int y, int w, int h,
    		double wx, double wy, int fill, int anchor)
    {
	GridBagLayout	lm = (GridBagLayout)ct.getLayout();
	GridBagConstraints gc = new GridBagConstraints();

	gc.gridx = x;
	gc.gridy = y;
	gc.weightx = wx;
	gc.weighty = wy;
	gc.gridwidth = w;
	gc.gridheight = h;
	gc.fill = fill;
	gc.anchor = anchor;
	lm.setConstraints(cp, gc);
	ct.add(cp);
    }
}
