import java.awt.*;

import aos.jack.jak.util.timer.DilationController;
import aos.util.Properties;

/**
   The Stck class is a simple presentation of runway information.
*/
class Stack extends Frame {

    List list;
    long [] item;

    Stack(String title,int index)
    {
	super(title);
	String prefix = "ATC.Runway."+index;
	int x = Properties.getIntProperty(prefix+".x",0);
	int y = Properties.getIntProperty(prefix+".y",0);
	int w = Properties.getIntProperty(prefix+".width",-1);
	int h = Properties.getIntProperty(prefix+".height",0);
	String font =
	    Properties.getStringProperty(prefix+".font","Courier-14");

	setFont(Font.decode(font));
	if (w != 1)
	    setSize(w,h);

	ScrollPane s = new ScrollPane();

	Label label = new Label("Callsign   ETA       ATL");
	add(label,"North");

	list = new List();
	s.add(list);

	add(s,"Center");
	setLocation(x,y);
	show();
    }

    String keyPart(String value)
    {
	return value.substring(value.length()-8);
    }

    int index(long key)
    {
	if (item == null)
	    return -1;
	for (int i=0; i<item.length; i++) {
	    if (key >= item[i])
		return i;
	}
	return item.length;
    }

    boolean sameRow(long key,int index)
    {
	if (index >= item.length)
	    return false;
	return (key == item[index]);
    }

    void addItem(long key,int at)
    {
	int size = (item==null)? 0 : item.length;
	long [] x = new long [size+1];
	for (int i=0; i<at; i++)
	    x[i] = item[i];
	x[at] = key;
	for (int i=at; i<size; i++)
	    x[i+1] = item[i];
	item = x;
    }

    void removeItem(int at)
    {
	if (item==null)
	    return;
	long [] x = new long [item.length-1];
	for (int i=0; i<at; i++)
	    x[i] = item[i];
	for (int i=at; i<x.length; i++)
	    x[i] = item[i+1];
	item = x;
    }

    void addRow(long key,String value)
    {
	String row = " "+value + " " + DilationController.timeString(key);
	int i = index(key);
	if (i == -1) {
	    list.addItem(row);
	    addItem(key,0);
	} else if (sameRow(key,i)) {
	    list.replaceItem(row,i);
	    item[i] = key;
	} else {
	    list.addItem(row,i);
	    addItem(key,i);
	}
    }

    void removeRow(long key)
    {
	int i = index(key);
	if (i == -1)
	    return;
	if (sameRow(key,i)) {
	    list.remove(i);
	    removeItem(i);
	}
    }
}
