import aos.jack.Kernel;
import aos.util.Properties;
import java.util.*;
import java.text.*;

/**
   This class implements the application main entry point.
*/
public class Main {

    static long baseTime;

    static MessageFormat syntax = new MessageFormat("{0,time,HH:mm}");

    public static void
    main(String [] argv)
    {
	// Initialise the JACK kernel immediately. This will process
	// the Jak.PropertyFile arguments, and in particular set up
	// the DilatedClock as default timer.
	argv = Kernel.init( argv, true );

	new Front();

	try {
	    Object [] b =
		syntax.parse(Properties.getStringProperty("ATC.baseTime",
							  "00:00"));
	    baseTime = ((Date)b[0]).getTime();
	}
	catch (ParseException e) {
	    baseTime = 0;
	}

	Kernel.getDefaultTimer().setTime(baseTime);

	try {
	    Object [] b = syntax.parse("00:00");
	    baseTime -= ((Date)b[0]).getTime();
	}
	catch (ParseException e) {
	}


	String airport =
	    Properties.getStringProperty("ATC.Airport.name","Sydney");

	Vector rwy = new Vector(10,10);

	for (int i=0; ; i++) {
	    String name =
		Properties.getStringProperty("ATC.Runway."+i+".name",null);
	    if (name == null)
		break;
	    rwy.addElement(name);
	}
	String [] runway = new String[rwy.size()];
	for (int i=0; i<runway.length; i++) {
	    runway[i] = (String)rwy.elementAt(i);
	}

	// Construct destination airport agent telling it the runways.
	new Airport(airport,runway);

	// Construct all feed airport agents
	for (int i=0; ; i++) {
	    String feeder =
		Properties.getStringProperty("ATC.Feeder."+i+".name",null);
	    if (feeder == null)
		break;
	    new Feeder(feeder,airport);
	}
    }
}
