import java.util.*;
import aos.jack.jak.core.Dci;

class Main
{
    public static void
    main(String [] args)
	throws Exception
    {
	boolean	startPingee	= true;
	boolean	startPinger	= true;
	int	index		= 0;

	//
	// Allow one optional argument to come before the real args
	// to choose to run only the pinger (-write) or pingee (-read).
	//
	if ( args.length > 0 && args[0].startsWith("-") ) {
	    if ( args[0].equals("-read") )
		startPinger = false;
	    else if ( args[0].equals("-write") )
		startPingee = false;
	    else {
		System.err.println(
"usage: java Main [-read|-write] [<pingee>] [<pinger> <pingee>@<host> <count>");
		System.exit(1);
	    }
	    index++;
	}

	// XXX - This could be removed. It is just
	// testing that things work in other locales.
	Locale.setDefault(Locale.KOREA);

	// Pass the command line arguments to JACK.
	// This is critical! It will process the DCI arguments (making the
	// desired connections) and strip them out, passing back a new array.
	//args = aos.jack.jak.core.Jak.initialize(args);
	args = aos.jack.Kernel.init(args);

	if ( startPingee ) {
	    System.err.println("starting \"Pingee(" + args[index+0] + ")\"");
	    new Pinger(args[index+0]);
	    System.err.println("host="+Dci.getHost());
	    System.err.println("port="+Dci.getPort());
	    index++;
	}

	if ( startPinger ) {
	    System.err.println("starting \"Pinger(" + args[index+0]
	    		+ " " + args[index+1] + " " + args[index+2] + ")\"");
	    new Pinger(args[index+0], args[index+1], args[index+2]);
	}


	String xxx = "";
	synchronized ( xxx ) {
	    xxx.wait();
	}
    }
}
