package GUI;

import java.lang.*;
import TamagotchiEnvironment.*;
import TamagotchiOntology.*;

public interface TamagotchiInterface {
  /** Returns the Tamagotchi's local environment */
  public TamagotchiShell getTamagotchiShell();
  /** Requests connection with another Tamagotchi */
  public void requestConnection();
  /** Sets the address of the other Tamagotchi */
  public void setFriend(String friend);
  /** Returns the address of the other Tamagotchi */
  public String getFriend();
  /** Changes the happiness level of the Tamagotchi */
  public void setHappinessLevel(double level);
  /** Returns the happiness level of the Tamagotchi */
  public double getHappinessLevel();
  /** Adds a present to the Tamagotchi's present list */
  public void addPresent(Present present);
  /** Retrieves a present from the Tamagotchi's present list */
  public Present getPresent();
}
